const rollup = require('rollup')
const path = require('path')

/**
 * 使用立即执行函数在整个文件上再包裹一层，因为babel可能会在最外层添加一些helper
 * @param {*} file
 * @param {*} options
 * @param {*} toDir
 */
module.exports = async (file, options, toDir) => {
  let base = path.relative(toDir, file)
  const bundle = await rollup.rollup({
    input: path.join(toDir, base),
  })

  await bundle.write({
    file: path.join(toDir, base),
    format: 'iife',
  })
}
